<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_ContactNumber ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_ContactNumber extends AbstractStructArrayBase
{
    /**
     * The PhoneNumber
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_ContactNumber[]
     */
    public $PhoneNumber;
    /**
     * Constructor method for ArrayOfJPSOAP_ContactNumber
     * @uses ArrayOfJPSOAP_ContactNumber::setPhoneNumber()
     * @param \StructType\JPSOAP_ContactNumber[] $phoneNumber
     */
    public function __construct(array $phoneNumber = array())
    {
        $this
            ->setPhoneNumber($phoneNumber);
    }
    /**
     * Get PhoneNumber value
     * @return \StructType\JPSOAP_ContactNumber[]|null
     */
    public function getPhoneNumber()
    {
        return $this->PhoneNumber;
    }
    /**
     * Set PhoneNumber value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_ContactNumber[] $phoneNumber
     * @return \ArrayType\ArrayOfJPSOAP_ContactNumber
     */
    public function setPhoneNumber(array $phoneNumber = array())
    {
        foreach ($phoneNumber as $arrayOfJPSOAP_ContactNumberPhoneNumberItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_ContactNumberPhoneNumberItem instanceof \StructType\JPSOAP_ContactNumber) {
                throw new \InvalidArgumentException(sprintf('The PhoneNumber property can only contain items of \StructType\JPSOAP_ContactNumber, "%s" given', is_object($arrayOfJPSOAP_ContactNumberPhoneNumberItem) ? get_class($arrayOfJPSOAP_ContactNumberPhoneNumberItem) : gettype($arrayOfJPSOAP_ContactNumberPhoneNumberItem)), __LINE__);
            }
        }
        $this->PhoneNumber = $phoneNumber;
        return $this;
    }
    /**
     * Add item to PhoneNumber value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_ContactNumber $item
     * @return \ArrayType\ArrayOfJPSOAP_ContactNumber
     */
    public function addToPhoneNumber(\StructType\JPSOAP_ContactNumber $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_ContactNumber) {
            throw new \InvalidArgumentException(sprintf('The PhoneNumber property can only contain items of \StructType\JPSOAP_ContactNumber, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PhoneNumber[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_ContactNumber|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_ContactNumber|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_ContactNumber|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_ContactNumber|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_ContactNumber|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PhoneNumber
     */
    public function getAttributeName()
    {
        return 'PhoneNumber';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_ContactNumber
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
